package com.jz.dmp.modules.controller.dataService.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @author Bellamy
 * @PACKAGE_NAME: com.jz.dm.models.req
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: CreateFolderReq
 * @DATE: 2021-1-27/18:12
 * @DAY_NAME_SHORT: 周三
 * @Description:
 **/
@Data
@ApiModel("创建文件请求体")
public class CreateFolderReq implements Serializable {

    @ApiModelProperty(value = "项目id", required = false)
    private Long projectId;

    @ApiModelProperty(value = "组织编码/编辑时不允许修改", required = false)
    private String orgCode;

    @ApiModelProperty(value = "父类文件夹id ,创建同级不传", required = false)
    private Long parentId;

    @ApiModelProperty(value = "文件夹名称", required = true)
    @NotNull(message = "文件夹名称不能为空!")
    @NotEmpty(message = "文件夹名称不能为空!")
    private String fileName;

    @ApiModelProperty(value = "文件来源:,1 API制做,2 组织创建", required = true)
    @NotEmpty(message = "文件来源不能为空")
    @NotNull(message = "文件来源不能为空")
    private String fileSource;

    @ApiModelProperty(value = "创建用户", required = false)
    private String createUser;

    //---------------------------------更新时id必传------------------
    @ApiModelProperty(value = "文件id", required = false)
    private String id;

    @ApiModelProperty(value = "更新用户", required = false)
    private String updateUser;

}
