package com.jz.dmp.modules.controller.sys;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jz.common.bean.BaseBeanResponse;
import com.jz.common.bean.BaseResponse;
import com.jz.common.bean.PageInfoResponse;
import com.jz.common.constant.StatuConstant;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberProjectRoleBatch;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberProjectRoleDto;
import com.jz.dmp.modules.controller.sys.bean.DmpMemberProjectRoleRequest;
import com.jz.dmp.modules.controller.sys.bean.MembProjRoleBatchReq;
import com.jz.dmp.modules.model.DmpMemberProjectRole;
import com.jz.dmp.modules.service.sys.DmpMemberProjectRoleService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

/**
 * 用户项目角色表Controller
 * @author ybz
 *
 */
@RestController
@RequestMapping("/dmp/member/project/role")
@Api(tags = "用户项目角色表")
public class DmpMemberProjectRoleController {
	
	@Autowired
	private DmpMemberProjectRoleService dmpMemberProjectRoleService;
	
	/**列表查询用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/findListWithPage")
	//@ApiOperation(value = "分頁列表查询用户项目角色表", notes = "分頁列表查询用户项目角色表")
	public PageInfoResponse<DmpMemberProjectRoleDto> findListWithPage(@RequestBody DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest){
		PageInfoResponse<DmpMemberProjectRoleDto> pageInfo = new PageInfoResponse<DmpMemberProjectRoleDto>();
		try {
			pageInfo = dmpMemberProjectRoleService.findListWithPage(dmpMemberProjectRoleRequest, httpRequest);
		} catch (Exception e) {
			pageInfo.setMessage("查询失败");
			pageInfo.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return pageInfo;
	}
	
	/**列表查询用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/findList")
	//@ApiOperation(value = "列表查询用户项目角色表", notes = "列表查询用户项目角色表")
	public BaseBeanResponse<DmpMemberProjectRoleDto> findList(@RequestBody DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest){
		BaseBeanResponse<DmpMemberProjectRoleDto> baseBeanResponse = new BaseBeanResponse<DmpMemberProjectRoleDto>();
		try {
			baseBeanResponse = dmpMemberProjectRoleService.findList(dmpMemberProjectRoleRequest, httpRequest);
		} catch (Exception e) {
			baseBeanResponse.setMessage("查询失败");
			baseBeanResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseBeanResponse;
	}
	
	
	/**主键查询用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/view")
	//@ApiOperation(value = "主键查询用户项目角色表", notes = "主键查询用户项目角色表")
	//@ApiImplicitParam(name = "memberProjectRoleId", value = "用户项目角色表主键")
	public BaseBeanResponse<DmpMemberProjectRoleDto> view(@RequestParam(name = "memberProjectRoleId", required = true ) Integer memberProjectRoleId, HttpServletRequest httpRequest){
		BaseBeanResponse<DmpMemberProjectRoleDto> baseBeanResponse = new BaseBeanResponse<DmpMemberProjectRoleDto>();
		try {
			baseBeanResponse = dmpMemberProjectRoleService.findById(memberProjectRoleId, httpRequest);
		} catch (Exception e) {
			baseBeanResponse.setMessage("请求失败");
			baseBeanResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseBeanResponse;
	}
	
	/**删除用户项目角色表
	 * @param memberProjectRoleId
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/delete")
	//@ApiOperation(value = "删除用户项目角色表", notes = "删除用户项目角色表")
	//@ApiImplicitParam(name = "memberProjectRoleId", value = "用户项目角色表主键")
	public BaseResponse delete(@RequestParam(name = "memberProjectRoleId", required = true ) Integer memberProjectRoleId, HttpServletRequest httpRequest){
		BaseResponse baseResponse = new BaseResponse();
		try {
			baseResponse = dmpMemberProjectRoleService.deleteById(memberProjectRoleId, httpRequest);
		} catch (Exception e) {
			baseResponse.setMessage("删除失败");
			baseResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseResponse;
	}
	
	/**软删除用户项目角色表
	 * @param memberProjectRoleId
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/softDelete")
	//@ApiOperation(value = "软删除用户项目角色表", notes = "软删除用户项目角色表")
	//@ApiImplicitParam(name = "memberProjectRoleId", value = "用户项目角色表主键")
	public BaseResponse softDelete(@RequestParam(name = "memberProjectRoleId", required = true ) Integer memberProjectRoleId, HttpServletRequest httpRequest){
		BaseResponse baseResponse = new BaseResponse();
		try {
			baseResponse = dmpMemberProjectRoleService.softDeleteById(memberProjectRoleId, httpRequest);
		} catch (Exception e) {
			baseResponse.setMessage("软删除失败");
			baseResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseResponse;
	}
	
	/**条件删除用户项目角色表
	 * @param memberProjectRoleId
	 * @return
	 */
	@RequestMapping(method = RequestMethod.POST, value = "/deleteByPojo")
	@ApiOperation(value = "条件删除用户项目角色表", notes = "删除用户项目角色表")
	public BaseResponse deleteByPojo(@RequestBody DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest){
		BaseResponse baseResponse = new BaseResponse();
		try {
			baseResponse = dmpMemberProjectRoleService.delete(dmpMemberProjectRoleRequest, httpRequest);
		} catch (Exception e) {
			baseResponse.setMessage("删除失败");
			baseResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseResponse;
	}
	
	/**条件软删除用户项目角色表
	 * @param memberProjectRoleId
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/softDeleteByPojo")
	//@ApiOperation(value = "条件软删除用户项目角色表", notes = "条件软删除用户项目角色表")
	public BaseResponse softDeleteByPojo(@RequestBody DmpMemberProjectRoleRequest dmpMemberProjectRoleRequest, HttpServletRequest httpRequest){
		BaseResponse baseResponse = new BaseResponse();
		try {
			baseResponse = dmpMemberProjectRoleService.softDelete(dmpMemberProjectRoleRequest, httpRequest);
		} catch (Exception e) {
			baseResponse.setMessage("软删除失败");
			baseResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseResponse;
	}
	
	/**新增用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	@RequestMapping(method = RequestMethod.POST, value = "/add")
	@ApiOperation(value = "新增用户项目角色表", notes = "新增用户项目角色表")
	public BaseBeanResponse<DmpMemberProjectRole> add(@RequestBody DmpMemberProjectRole dmpMemberProjectRole, HttpServletRequest httpRequest){
		BaseBeanResponse<DmpMemberProjectRole> baseBeanResponse = new BaseBeanResponse<DmpMemberProjectRole>();
		try {
			baseBeanResponse = dmpMemberProjectRoleService.add(dmpMemberProjectRole, httpRequest);
		} catch (Exception e) {
			baseBeanResponse.setMessage("新增失败");
			baseBeanResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseBeanResponse;
	}
	
	/**批量新增用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/addBatch")
	//@ApiOperation(value = "批量新增用户项目角色表", notes = "批量新增用户项目角色表")
	public BaseBeanResponse<DmpMemberProjectRoleBatch> addBatch(@RequestBody DmpMemberProjectRoleBatch dmpMemberProjectRoleBatch, HttpServletRequest httpRequest){
		BaseBeanResponse<DmpMemberProjectRoleBatch> baseBeanResponse = new BaseBeanResponse<DmpMemberProjectRoleBatch>();
		try {
			baseBeanResponse = dmpMemberProjectRoleService.addBatch(dmpMemberProjectRoleBatch, httpRequest);
		} catch (Exception e) {
			baseBeanResponse.setMessage("批量新增失败");
			baseBeanResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseBeanResponse;
	}
	
	/**修改用户项目角色表
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	//@RequestMapping(method = RequestMethod.POST, value = "/edit")
	//@ApiOperation(value = "修改用户项目角色表", notes = "修改用户项目角色表")
	public BaseBeanResponse<DmpMemberProjectRole> edit(@RequestBody DmpMemberProjectRole dmpMemberProjectRole, HttpServletRequest httpRequest){
		BaseBeanResponse<DmpMemberProjectRole> baseBeanResponse = new BaseBeanResponse<DmpMemberProjectRole>();
		try {
			baseBeanResponse = dmpMemberProjectRoleService.edit(dmpMemberProjectRole, httpRequest);
		} catch (Exception e) {
			baseBeanResponse.setMessage("修改失败");
			baseBeanResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseBeanResponse;
	}
	
	/**项目成员添加
	 * @param dmpMemberProjectRoleRequest
	 * @return
	 */
	@RequestMapping(method = RequestMethod.POST, value = "/addProjMembers")
	@ApiOperation(value = "项目成员添加", notes = "项目成员添加")
	public BaseBeanResponse<DmpMemberProjectRole> addProjMembers(@RequestBody MembProjRoleBatchReq membProjRoleBatchReq, HttpServletRequest httpRequest){
		BaseBeanResponse<DmpMemberProjectRole> baseBeanResponse = new BaseBeanResponse<DmpMemberProjectRole>();
		try {
			baseBeanResponse = dmpMemberProjectRoleService.addProjMembers(membProjRoleBatchReq, httpRequest);
		} catch (Exception e) {
			baseBeanResponse.setMessage("批量添加项目成员失败");
			baseBeanResponse.setCode(StatuConstant.FAILURE_CODE);
			e.printStackTrace();
		}
		
		return baseBeanResponse;
	}
	
}
